﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Navigation
Imports System.Windows.Ria
Imports System.Windows.Ria.ApplicationServices
Imports System.Windows.Ria.Data
Imports System.Windows.Data
Imports System.ComponentModel
Imports AlexApp

Namespace ExpenseReport
	''' <summary>
	''' The base page for the application which contains a frame that is used for navigation.  The page
	''' has a collapased "Create Data" button that can be used to create sample data in a database.
	''' </summary>
	Partial Public Class ExpenseReportApp
		Inherits Page
		Private employees As List(Of Employee)
		Private expenseDataContext As ExpenseData

		Public Sub New()
			InitializeComponent()
		End Sub


		Private Sub CreateData_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			expenseDataContext = New ExpenseData()
			AddHandler expenseDataContext.Loaded, AddressOf expenseDataContext_Loaded
			expenseDataContext.LoadEmployees()

		End Sub

		Private Sub expenseDataContext_Loaded(ByVal sender As Object, ByVal e As LoadedDataEventArgs)
			RemoveHandler expenseDataContext.Loaded, AddressOf expenseDataContext_Loaded
			CreateSampleData()
		End Sub

		Private Sub CreateSampleData()
			Dim states As New List(Of String)(New String() { "Alabama", "Alaska", "Arizona", "Arkansas", "California", "Colorado", "Connecticut", "Delaware", "Florida", "Georgia", "Hawaii", "Idaho", "Illinois", "Indiana", "Iowa", "Kansas", "Kentucky", "Louisiana", "Maine", "Maryland", "Massachusetts", "Michigan, Minnesota", "Mississippi", "Missouri", "Montana", "Nebraska", "Nevada", "New Hampshire", "New Jersey", "New Mexico", "New York", "North Carolina", "North Dakota", "Ohio", "Oklahoma", "Oregon", "Pennsylvania", "Rhode Island", "South Carolina", "South Dakota", "Tennessee", "Texas", "Utah", "Vermont", "Virginia ", "Washington", "West Virginia", "Wisconsin", "Wyoming" })
			Dim abbreviations As New List(Of String)(New String() { "AL", "AK", "AZ", "AR", "CA", "CO", "CT", "DE", "FL", "GA", "HI", "ID", "IL", "IN", "IA", "KS", "KY", "LA", "ME", "MD", "MA", "MI", "MN", "MS", "MO", "MT", "NE", "NV", "NH", "NJ", "NM", "NY", "NC", "ND", "OH", "OK", "OR", "PA", "RI", "SC", "SD", "TN", "TX", "UT", "VT", "VA", "WA", "WV", "WI", "WY" })
			Dim details As New List(Of String)(New String() { "Rental Car", "Hotel Stay", "Gas", "Meals" })
			employees = expenseDataContext.Employees.ToList()

			Dim i As Integer = 0
			Dim r As New Random()
			For Each state As String In states
				Dim er As New ExpenseReport() With {.id = states.IndexOf(state)+1, .Company = "Company" & state.Chars(0), .Created = New DateTime(r.Next(1900, 2008), r.Next(1, 12), r.Next(1, 28)), .Department = "Dept " & (If(i = 0, "A", "B")), .Employee = employees(i), .Status = r.Next(0, 3), .Description = "Trip to " & state}
				For Each detail As String In details
					Dim erd As New ExpenseReportDetails() With {.expensereportid = states.IndexOf(state) + 1, .Amount = CType((r.NextDouble() + 0.1) * 800.0, Decimal), .Category = detail, .City = "Big City", .State = abbreviations(states.IndexOf(state)), .ShortDescription = detail & " purchase", .LongDescription = detail & " expense during " & state & " trip.", .CreditCardExpense = If(i = 0, False, True), .DateIncurred = New DateTime(er.Created.Value.Year, r.Next(1, er.Created.Value.Month), r.Next(1, er.Created.Value.Day))}
					expenseDataContext.ExpenseReportDetails.Add(erd)
					er.ExpenseReportDetails.Add(erd)
				Next detail
				expenseDataContext.ExpenseReports.Add(er)
				i = If(i = 0, 1, 0)
			Next state
			AddHandler expenseDataContext.Submitted, AddressOf expenseDataContext_Submitted
			expenseDataContext.SubmitChanges()
		End Sub

		Private Sub expenseDataContext_Submitted(ByVal sender As Object, ByVal e As SubmittedChangesEventArgs)
			RemoveHandler expenseDataContext.Submitted, AddressOf expenseDataContext_Submitted
			If e.EntitiesInError.Count() > 0 Then
				Throw New Exception()
			End If
		End Sub
	End Class
End Namespace
