﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Ria.Data
Imports System.Windows.Shapes

Namespace ExpenseReport
	Partial Public Class ModifyExpenseDetailChildWindow
		Inherits ChildWindow
		Private _detailItem As ExpenseReportDetails

		''' <summary>
		''' Allows the current item of the dataform's expense report details to be set.
		''' </summary>
		Public Property DetailItem() As ExpenseReportDetails
			Get
				Return _detailItem
			End Get

			Set(ByVal value As ExpenseReportDetails)
				_detailItem = value
				detailForm.CurrentItem = value
			End Set
		End Property

		Private privateParentDomainContext As ExpenseData
		Public Property ParentDomainContext() As ExpenseData
			Get
				Return privateParentDomainContext
			End Get
			Set(ByVal value As ExpenseData)
				privateParentDomainContext = value
			End Set
		End Property
		Private privateParentExpenseReport As ExpenseReport
		Public Property ParentExpenseReport() As ExpenseReport
			Get
				Return privateParentExpenseReport
			End Get
			Set(ByVal value As ExpenseReport)
				privateParentExpenseReport = value
			End Set
		End Property

		Public Sub New()
			InitializeComponent()
			AddHandler detailForm.ItemEditEnded, AddressOf detailForm_ItemEditEnded
			AddHandler detailForm.AutoGeneratingField, AddressOf detailForm_AutoGeneratingField
		End Sub

		''' <summary>
		''' Prevents ExpenseReport and ExpenseReport ID from showing in the data form.
		''' </summary>
		''' <param name="sender">DataForm</param>
		''' <param name="e">DataFormAutoGeneratingFieldEventArgs generated by DataForm's AutoGeneratingField event</param>
		Private Sub detailForm_AutoGeneratingField(ByVal sender As Object, ByVal e As DataFormAutoGeneratingFieldEventArgs)
			If e.PropertyName = "ExpenseReport" OrElse e.PropertyName = "expensereportid" Then
				e.Cancel = True
			End If
		End Sub

		''' <summary>
		'''After item editing is completed, adds the detail item to the parent expense report and domain context.
		'''This allows new items to be cancelled before they are added as children.
		''' </summary>
		''' <param name="sender">DataForm</param>
		''' <param name="e">DataFormAutoGeneratingFieldEventArgs generated by DataForm's AutoGeneratingField event</param>
		Private Sub detailForm_ItemEditEnded(ByVal sender As Object, ByVal e As DataFormItemEditEndedEventArgs)
			Dim detail As ExpenseReportDetails = CType(detailForm.CurrentItem, ExpenseReportDetails)
			If e.EditAction = DataFormEditAction.Commit AndAlso detail.EntityState = EntityState.New AndAlso ParentDomainContext IsNot Nothing Then
				ParentExpenseReport.ExpenseReportDetails.Add(detail)
				ParentDomainContext.ExpenseReportDetails.Add(detail)

			End If
			'This form was called to add a new ExpenseReportDetail.
			If Me.DataContext.Equals(detail) Then
				ParentDomainContext = Nothing
				Me.Close()
			End If
		End Sub
	End Class
End Namespace

