﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Linq
Imports System.Web
Imports System.Web.DomainServices

Namespace ExpenseReport
	''' <summary>
	''' ExpeneseReport partial class used to associate the class with a metadata class.
	''' </summary>
	<MetadataType(GetType(ExpenseReportMetadata))> _
	Partial Public Class ExpenseReport
	End Class

	''' <summary>
	''' Metadata class for ExpenseReport used to apply metadata to ExpenseReport properties.
	''' </summary>
	Partial Public Class ExpenseReportMetadata
		<Bindable(True, BindingDirection.TwoWay), StringLength(10), Display(Name := "Company", Description := "Company where you work.")> _
		Public Shared Company As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Created Date", Description := "Date of the expense report.")> _
		Public Shared Created As Object

		<Bindable(True, BindingDirection.TwoWay), StringLength(10), Display(Name := "Department", Description := "Department where you work")> _
		Public Shared Department As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Description", Description := "Description of the reason for the expenses.")> _
		Public Shared Description As Object

		<Include, Display(Name := "Details", Description := "Expense Report Line Items.")> _
		Public Shared ExpenseReportDetails As Object

		<Include> _
		Public Shared Employee As Object

		<Bindable(False)> _
		Public Shared id As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Status", Description := "The status of the expense report.")> _
		Public Shared Status As Object
	End Class

	''' <summary>
	''' ExpenseReportDetails partial class used to associate the class with a metadata class.
	''' </summary>
	<MetadataType(GetType(ExpenseReportDetailsMetadata)), CustomValidation(GetType(ExpenseReportValidation),"ValidateDescription")> _
	Partial Public Class ExpenseReportDetails
	End Class

	''' <summary>
	''' Metadata class for ExpenseReportDetails used to apply metadata to ExpenseReportDetails properties.
	''' </summary>
	Partial Public Class ExpenseReportDetailsMetadata
		<Bindable(True, BindingDirection.TwoWay), Required, Display(Name := "Expense Amount", Description := "The amount of the incurred expense."), Range(0.0, 1000000.00)> _
		Public Shared Amount As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Category", Description := "The category of expense, i.e., mileage."), StringLength(10)> _
		Public Shared Category As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "City", Description := "The city where the expense was incurred."), StringLength(50)> _
		Public Shared City As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Expensed on Credit Card", Description := "Was a credit card used to pay this expense.")> _
		Public Shared CreditCardExpense As Object

		<Bindable(True, BindingDirection.TwoWay), CustomValidation(GetType(ExpenseReportValidation),"ValidateDateIncurred"), Display(Name := "Date", Description := "The date of when this expense was incurred."), Required> _
		Public Shared DateIncurred As Object

		<Bindable(False)> _
		Public Shared ExpenseReport As Object

		<Bindable(False)> _
		Public Shared id As Object

		<Bindable(False), Display(Name := "Line Item", Description := "The line number of the expense.")> _
		Public Shared LineItem As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Detailed Description", Description := "A detailed description for the expense."), StringLength(500)> _
		Public Shared LongDescription As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Summary", Description := "A short description for the expense."), StringLength(50), Required> _
		Public Shared ShortDescription As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "State", Description := "The state where the expense was incurred."), StringLength(2)> _
		Public Shared State As Object
	End Class

	''' <summary>
	''' Employee partial class used to associate the class with a metadata class.
	''' </summary>
	<MetadataType(GetType(EmployeeMetadata))> _
	Partial Public Class Employee
	End Class

	''' <summary>
	''' Metadata class for Employee used to apply metadata to Employee properties.
	''' </summary>
	Partial Public Class EmployeeMetadata
		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Login ID of employee", Description := "Login ID of employee.")> _
		Public Shared employee As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Login ID of manager", Description := "Login ID of employee's manager.")> _
		Public Shared manager As Object

		<Bindable(True, BindingDirection.TwoWay), Display(Name := "Name", Description := "The name of employee.")> _
		Public Shared Name As Object
	End Class

End Namespace